| # Gaudi Framework, version v20r2
Generated: 18 Jul 2008

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Search for |

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# NTuple::Tuple Class Reference

`#include <NTuple.h>`

Inheritance diagram for NTuple::Tuple:

[legend]
Collaboration diagram for NTuple::Tuple:

[legend]
List of all members.

## Detailed Description

Abstract base class which allows the user to interact with the actual N tuple implementation.

The class is abstract, because the template methods must be instantiated by the compiler at compile time. Otherwise the references would be unresolved.

Definition at line 365 of file NTuple.h.

## Public Member Functions
virtual | ~Tuple ()
| Standard destructor.
template<class TYPE>
StatusCode | item (const std::string &name, Item< TYPE > &result)
| Locate a scalar Item of data to the N tuple type safe.
template<class TYPE>
StatusCode | item (const std::string &name, const Item< TYPE > &result) const
| Locate a scalar Item of data to the N tuple type safe (CONST).
template<class TYPE>
StatusCode | item (const std::string &name, Array< TYPE > &result)
| Locate a Array of data to the N tuple type safe.
template<class TYPE>
StatusCode | item (const std::string &name, const Array< TYPE > &result) const
| Locate a Array of data to the N tuple type safe (CONST).
template<class TYPE>
StatusCode | item (const std::string &name, Matrix< TYPE > &result)
| Locate a Matrix of data to the N tuple type safe.
template<class TYPE>
StatusCode | item (const std::string &name, const Matrix< TYPE > &result) const
| Locate a Matrix of data to the N tuple type safe (CONST).
template<class TYPE>
StatusCode | addItem (const std::string &name, Item< TYPE > &itm)
| Add a scalar data item a N tuple.
template<class TYPE>
StatusCode | addItem (const std::string &name, Item< TYPE * > &itm)
| Add an simple object item to an N tuple.
StatusCode | addItem (const std::string &name, Item< IOpaqueAddress * > &itm)
| Add an address object item to an N tuple: specialized call.
template<class TYPE, class RANGE>
StatusCode | addItem (const std::string &name, Item< TYPE > &itm, const RANGE low, const RANGE high)
| Add a scalar data item a N tuple with a range.
template<class TYPE>
StatusCode | addItem (const std::string &name, long dim, Array< TYPE > &array)
| Add an fixed-size Array of data to a column wise N tuple.
template<class TYPE, class RANGE>
StatusCode | addItem (const std::string &name, long dim, Array< TYPE > &array, const RANGE low, const RANGE high)
| Add an fixed-size Array of data to a column wise N tuple with a range.
template<class TYPE, class INDEX, class RANGE>
StatusCode | addItem (const std::string &name, Item< INDEX > &index, Array< TYPE > &array, const RANGE low, const RANGE high)
| Add an indexed Array of data to a column wise N tuple with a range.
template<class TYPE, class INDEX, class RANGE>
StatusCode | addIndexedItem (const std::string &name, Item< INDEX > &index, Array< TYPE > &array, const RANGE low, const RANGE high)
| Add an indexed Array of data to a column wise N tuple with a range.
template<class TYPE, class INDEX>
StatusCode | addItem (const std::string &name, Item< INDEX > &index, Array< TYPE > &array)
| Add an indexed Array of data to a column wise N tuple.
template<class TYPE, class INDEX>
StatusCode | addIndexedItem (const std::string &name, Item< INDEX > &index, Array< TYPE > &array)
| Add an indexed Array of data to a column wise N tuple.
template<class TYPE>
StatusCode | addItem (const std::string &name, long cols, long rows, Matrix< TYPE > &matrix)
| Add an fixed size Matrix of data to a column wise N tuple.
template<class TYPE, class RANGE>
StatusCode | addItem (const std::string &name, long cols, long rows, Matrix< TYPE > &result, const RANGE low, const RANGE high)
| Add an fixed size Matrix of data to a column wise N tuple.
template<class TYPE, class INDEX>
StatusCode | addItem (const std::string &name, Item< INDEX > &index, Matrix< TYPE > &matrix, long rows)
| Add an variable size Matrix of data to a column wise N tuple.
template<class TYPE, class INDEX>
StatusCode | addIndexedItem (const std::string &name, Item< INDEX > &col_index, long rows, Matrix< TYPE > &matrix)
| Add an variable size Matrix of data to a column wise N tuple.
template<class TYPE, class INDEX, class RANGE>
StatusCode | addItem (const std::string &name, Item< INDEX > &index, Matrix< TYPE > &matrix, long rows, const RANGE low, const RANGE high)
| Add an variable size Matrix of data to a column wise N tuple.
template<class TYPE, class INDEX, class RANGE>
StatusCode | addIndexedItem (const std::string &name, Item< INDEX > &index, long rows, Matrix< TYPE > &matrix, const RANGE low, const RANGE high)
| Add an variable size Matrix of data to a column wise N tuple.
## Protected Member Functions
template<class TYPE>
StatusCode | i_item (const std::string &name, _Item< TYPE > *&result) const
| Locate a _Column of data to the N tuple type safe.
template<class TYPE>
StatusCode | i_item (const std::string &name, _Item< TYPE * > *&result) const
| Locate a _Column of data to the N tuple type unsafe for objects.
StatusCode | i_item (const std::string &name, _Item< IOpaqueAddress * > *&result) const
| Locate a _Column of data to the N tuple type safe.
template<class TYPE>
StatusCode | i_item (const std::string &name, _Array< TYPE > *&result) const
| Locate a _Array of data to the N tuple type safe.
template<class TYPE>
StatusCode | i_item (const std::string &name, _Matrix< TYPE > *&result) const
| Locate a _Matrix of data to the N tuple type safe.
template<class TYPE>
StatusCode | i_addItem (const std::string &name, long, const std::string &, TYPE low, TYPE high, _Item< TYPE > *&result)
| Add a _Item of data to the N tuple.
template<class TYPE>
StatusCode | i_addItem (const std::string &name, long dim, const std::string &index, TYPE low, TYPE high, _Array< TYPE > *&result)
| Add a _Item of data to the N tuple.
template<class TYPE>
StatusCode | i_addItem (const std::string &name, long dim1, long dim2, const std::string &index, TYPE low, TYPE high, _Matrix< TYPE > *&result)
| Add a _Item of data to the N tuple.
template<class TYPE>
StatusCode | i_addObject (const std::string &name, _Item< TYPE * > *&result, const std::type_info &)

## Constructor & Destructor Documentation

virtual NTuple::Tuple::~Tuple | ( |  | ) | `[inline, virtual]`

Standard destructor.

Definition at line 495 of file NTuple.h.

    00495                        {
    00496     }

## Member Function Documentation

template<class TYPE>

StatusCode NTuple::Tuple::i_item | ( | const std::string & | name,
|  | _Item< TYPE > *& | result |
| ) |  |  | const`[inline, protected]`

Locate a _Column of data to the N tuple type safe.

Definition at line 369 of file NTuple.h.

References StatusCode::FAILURE, INTuple::i_find(), DataObject::name(), and StatusCode::SUCCESS.

Referenced by item().

    00370                                                                            {
    00371       try   {
    00372         result = dynamic_cast< _Item<TYPE>* > (i_find(name));
    00373       }
    00374       catch (...)   {
    00375         result = 0;
    00376       }
    00377       return (0==result) ? StatusCode::FAILURE : StatusCode::SUCCESS;
    00378     }

template<class TYPE>

StatusCode NTuple::Tuple::i_item | ( | const std::string & | name,
|  | _Item< TYPE * > *& | result |
| ) |  |  | const`[inline, protected]`

Locate a _Column of data to the N tuple type unsafe for objects.

Definition at line 380 of file NTuple.h.

References StatusCode::FAILURE, INTuple::i_find(), DataObject::name(), and StatusCode::SUCCESS.

    00381                                                                             {
    00382       try   {
    00383         _Item<void*>* p = dynamic_cast< _Item<void*>* > (i_find(name));
    00384         result = (_Item<TYPE*>*)p;
    00385       }
    00386       catch (...)   {
    00387         result = 0;
    00388       }
    00389       return (0==result) ? StatusCode::FAILURE : StatusCode::SUCCESS;
    00390     }

StatusCode NTuple::Tuple::i_item | ( | const std::string & | name,
|  | _Item< IOpaqueAddress * > *& | result |
| ) |  |  | const`[inline, protected]`

Locate a _Column of data to the N tuple type safe.

Definition at line 392 of file NTuple.h.

References StatusCode::FAILURE, INTuple::i_find(), DataObject::name(), and StatusCode::SUCCESS.

    00393                                                                                       {
    00394       try   {
    00395         result = dynamic_cast< _Item<IOpaqueAddress*>* > (i_find(name));
    00396       }
    00397       catch (...)   {
    00398         result = 0;
    00399       }
    00400       return (0==result) ? StatusCode::FAILURE : StatusCode::SUCCESS;
    00401     }

template<class TYPE>

StatusCode NTuple::Tuple::i_item | ( | const std::string & | name,
|  | _Array< TYPE > *& | result |
| ) |  |  | const`[inline, protected]`

Locate a _Array of data to the N tuple type safe.

Definition at line 403 of file NTuple.h.

References DataObject::clID(), CLID_ColumnWiseTuple, StatusCode::FAILURE, INTuple::i_find(), DataObject::name(), and StatusCode::SUCCESS.

    00404                                                                             {
    00405       try   {
    00406         if ( clID() == CLID_ColumnWiseTuple )   {
    00407           result = dynamic_cast< _Array<TYPE>* > (i_find(name));
    00408         }
    00409       }
    00410       catch (...)   {
    00411         result = 0;
    00412       }
    00413       return (0==result) ? StatusCode::FAILURE : StatusCode::SUCCESS;
    00414     }

template<class TYPE>

StatusCode NTuple::Tuple::i_item | ( | const std::string & | name,
|  | _Matrix< TYPE > *& | result |
| ) |  |  | const`[inline, protected]`

Locate a _Matrix of data to the N tuple type safe.

Definition at line 416 of file NTuple.h.

References DataObject::clID(), CLID_ColumnWiseTuple, StatusCode::FAILURE, INTuple::i_find(), DataObject::name(), and StatusCode::SUCCESS.

    00417                                                                              {
    00418       try   {
    00419         if ( clID() == CLID_ColumnWiseTuple )   {
    00420           result = dynamic_cast< _Matrix<TYPE>* > (i_find(name));
    00421         }
    00422       }
    00423       catch (...)   {
    00424         result = 0;
    00425       }
    00426       return (0==result) ? StatusCode::FAILURE : StatusCode::SUCCESS;
    00427     }

template<class TYPE>

StatusCode NTuple::Tuple::i_addItem | ( | const std::string & | name,
|  | long | ,
|  | const std::string & | ,
|  | TYPE | low,
|  | TYPE | high,
|  | _Item< TYPE > *& | result |
| ) |  |  | `[inline, protected]`

Add a _Item of data to the N tuple.

Definition at line 430 of file NTuple.h.

References INTuple::add(), StatusCode::FAILURE, INTuple::i_find(), and DataObject::name().

Referenced by addIndexedItem(), and addItem().

    00435                                                  {
    00436       if ( !i_find(name) )    {
    00437         TYPE nil;
    00438         nil = 0;
    00439         return add( result = _Item<TYPE>::create(this, name, typeid(TYPE), low, high, nil) );
    00440       }
    00441       return StatusCode::FAILURE;
    00442     }

template<class TYPE>

StatusCode NTuple::Tuple::i_addItem | ( | const std::string & | name,
|  | long | dim,
|  | const std::string & | index,
|  | TYPE | low,
|  | TYPE | high,
|  | _Array< TYPE > *& | result |
| ) |  |  | `[inline, protected]`

Add a _Item of data to the N tuple.

Definition at line 445 of file NTuple.h.

References INTuple::add(), DataObject::clID(), CLID_ColumnWiseTuple, StatusCode::FAILURE, INTuple::i_find(), and DataObject::name().

    00450                                                   {
    00451       if ( !i_find(name) && clID() == CLID_ColumnWiseTuple )    {
    00452         return add( result = _Array<TYPE>::create(this,
    00453                                                   name,
    00454                                                   typeid(TYPE),
    00455                                                   index,
    00456                                                   dim,
    00457                                                   low,
    00458                                                   high,
    00459                                                   TYPE(0)) );
    00460       }
    00461       return StatusCode::FAILURE;
    00462     }

template<class TYPE>

StatusCode NTuple::Tuple::i_addItem | ( | const std::string & | name,
|  | long | dim1,
|  | long | dim2,
|  | const std::string & | index,
|  | TYPE | low,
|  | TYPE | high,
|  | _Matrix< TYPE > *& | result |
| ) |  |  | `[inline, protected]`

Add a _Item of data to the N tuple.

Definition at line 465 of file NTuple.h.

References INTuple::add(), DataObject::clID(), CLID_ColumnWiseTuple, StatusCode::FAILURE, INTuple::i_find(), and DataObject::name().

    00471                                                    {
    00472       if ( !i_find(name) && clID() == CLID_ColumnWiseTuple )    {
    00473         return add( result = _Matrix<TYPE>::create(this,
    00474                                                    name,
    00475                                                    typeid(TYPE),
    00476                                                    index,
    00477                                                    dim1,
    00478                                                    dim2,
    00479                                                    low,
    00480                                                    high,
    00481                                                    TYPE(0)) );
    00482       }
    00483       return StatusCode::FAILURE;
    00484     }

template<class TYPE>

StatusCode NTuple::Tuple::i_addObject | ( | const std::string & | name,
|  | _Item< TYPE * > *& | result,
|  | const std::type_info & |  |
| ) |  |  | `[inline, protected]`

Definition at line 486 of file NTuple.h.

References INTuple::add(), DataObject::clID(), CLID_ColumnWiseTuple, StatusCode::FAILURE, INTuple::i_find(), and DataObject::name().

Referenced by addItem().

    00486                                                                                             {
    00487       if ( !i_find(name) && clID() == CLID_ColumnWiseTuple )    {
    00488         return add( result = (_Item<TYPE*>*)_Item<void*>::create(this, name, typeid(TYPE),0,0,0) );
    00489       }
    00490       return StatusCode::FAILURE;
    00491     }

template<class TYPE>

StatusCode NTuple::Tuple::item | ( | const std::string & | name,
|  | Item< TYPE > & | result |
| ) |  |  | `[inline]`

Locate a scalar Item of data to the N tuple type safe.

Definition at line 498 of file NTuple.h.

References i_item(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

Referenced by NTuple::TupleImp::add(), and NTuple::TupleImp::remove().

    00500     {
    00501       return i_item(name, result.m_ptr);
    00502     }

template<class TYPE>

StatusCode NTuple::Tuple::item | ( | const std::string & | name,
|  | const Item< TYPE > & | result |
| ) |  |  | const`[inline]`

Locate a scalar Item of data to the N tuple type safe (CONST).

Definition at line 504 of file NTuple.h.

References i_item(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00506     {
    00507       return i_item(name, result.m_ptr);
    00508     }

template<class TYPE>

StatusCode NTuple::Tuple::item | ( | const std::string & | name,
|  | Array< TYPE > & | result |
| ) |  |  | `[inline]`

Locate a Array of data to the N tuple type safe.

Definition at line 511 of file NTuple.h.

References i_item(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00512     {
    00513       return i_item(name, result.m_ptr);
    00514     }

template<class TYPE>

StatusCode NTuple::Tuple::item | ( | const std::string & | name,
|  | const Array< TYPE > & | result |
| ) |  |  | const`[inline]`

Locate a Array of data to the N tuple type safe (CONST).

Definition at line 516 of file NTuple.h.

References i_item(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00518     {
    00519       return i_item(name, result.m_ptr);
    00520     }

template<class TYPE>

StatusCode NTuple::Tuple::item | ( | const std::string & | name,
|  | Matrix< TYPE > & | result |
| ) |  |  | `[inline]`

Locate a Matrix of data to the N tuple type safe.

Definition at line 522 of file NTuple.h.

References i_item(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00524     {
    00525       return i_item(name, result.m_ptr);
    00526     }

template<class TYPE>

StatusCode NTuple::Tuple::item | ( | const std::string & | name,
|  | const Matrix< TYPE > & | result |
| ) |  |  | const`[inline]`

Locate a Matrix of data to the N tuple type safe (CONST).

Definition at line 529 of file NTuple.h.

References i_item(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00531     {
    00532       return i_item(name, result.m_ptr);
    00533     }

template<class TYPE>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | Item< TYPE > & | itm |
| ) |  |  | `[inline]`

Add a scalar data item a N tuple.

Use this entry point to connect any allowed scalar data type to an N-tuple. The value filled, may have any range. Do NOT use this entry point to specify an index column in a column wise N-tuple.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | itm | Reference to the Item<TYPE> datatype, which should be connected to the N-tuple.

Returns:
  StatusCode indicating success or failure.

Definition at line 549 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, min, and DataObject::name().

Referenced by Tuples::TupleObj::addresses(), Tuples::TupleObj::floats(), Tuples::ItemStore< VALUE >::getItem(), and Tuples::TupleObj::ints().

    00549                                                      {
    00550       typedef Range<TYPE> _R;
    00551       return i_addItem(name, 1, "", _R::min(), _R::max(), itm.m_ptr);
    00552     }

template<class TYPE>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | Item< TYPE * > & | itm |
| ) |  |  | `[inline]`

Add an simple object item to an N tuple.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | itm | Reference to the Item<TYPE> datatype, which should be connected to the N-tuple.

Returns:
  StatusCode indicating success or failure.

Definition at line 563 of file NTuple.h.

References i_addObject(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00563                                                      {
    00564       return i_addObject(name,itm.m_ptr,typeid(TYPE));
    00565     }

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | Item< IOpaqueAddress * > & | itm |
| ) |  |  | `[inline]`

Add an address object item to an N tuple: specialized call.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | itm | Reference to the Item<TYPE> datatype, which should be connected to the N-tuple.

Returns:
  StatusCode indicating success or failure.

Definition at line 576 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, min, and DataObject::name().

    00576                                                                {
    00577       typedef Range<IOpaqueAddress*> _R;
    00578       return i_addItem(name, 1, "", _R::min(), _R::max(), itm.m_ptr);
    00579     }

template<class TYPE, class RANGE>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | Item< TYPE > & | itm,
|  | const RANGE | low,
|  | const RANGE | high |
| ) |  |  | `[inline]`

Add a scalar data item a N tuple with a range.

Typically this entry point is used to specuify index column with a fixed data range for a column wise N-tuple.

Note: Checks on the data range are not implemented!

Parameters:

  | name | Name of the column in the column wise N-tuple
  | itm | Reference to the Item<TYPE> datatype, which should be connected to the N-tuple.
  | low | Lower edge of client data values allowed to fill into the N-tuple array.
  | high | Upper edge of client data values allowed to fill into the N-tuple array.

Returns:
  StatusCode indicating success or failure.

Definition at line 599 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00603     {
    00604       return i_addItem( name, 1, "", TYPE(low), TYPE(high), itm.m_ptr);
    00605     }

template<class TYPE>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | long | dim,
|  | Array< TYPE > & | array |
| ) |  |  | `[inline]`

Add an fixed-size Array of data to a column wise N tuple.

You should use this entry point to add a FIXED SIZE ARRAY to a column wise N-tuple. The dimension of the array must be specified.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | dim | Length of the array to be added to the N-tuple
  | array | Reference to the Array<TYPE> datatype, which should be connected to the N-tuple.

Returns:
  StatusCode indicating success or failure.

Definition at line 621 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00624     {
    00625       return i_addItem(name,
    00626                        dim,
    00627                        "",
    00628                        Range<TYPE>::min(),
    00629                        Range<TYPE>::max(),
    00630                        array.m_ptr);
    00631     }

template<class TYPE, class RANGE>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | long | dim,
|  | Array< TYPE > & | array,
|  | const RANGE | low,
|  | const RANGE | high |
| ) |  |  | `[inline]`

Add an fixed-size Array of data to a column wise N tuple with a range.

You should use this entry point to add a FIXED SIZE ARRAY to a column wise N-tuple. The dimension of the array must be specified.

Note: Checks on the data range are not implemented!

Parameters:

  | name | Name of the column in the column wise N-tuple
  | dim | Length of the array to be added to the N-tuple
  | array | Reference to the Array<TYPE> datatype, which should be connected to the N-tuple.
  | low | Lower edge of client data values allowed to fill into the N-tuple array.
  | high | Upper edge of client data values allowed to fill into the N-tuple array.

Returns:
  StatusCode indicating success or failure.

Definition at line 653 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00658     {
    00659       return i_addItem(name,
    00660                        dim,
    00661                        "",
    00662                        TYPE(low),
    00663                        TYPE(high),
    00664                        array.m_ptr);
    00665     }

template<class TYPE, class INDEX, class RANGE>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | Item< INDEX > & | index,
|  | Array< TYPE > & | array,
|  | const RANGE | low,
|  | const RANGE | high |
| ) |  |  | `[inline]`

Add an indexed Array of data to a column wise N tuple with a range.

You should use this entry point to add a VARIABLE SIZE ARRAY to a column wise N-tuple. The dimension of the array is unspecified and depends on the data range, which you allowed for the index column.

Hence you have to be careful on the allowed data range of the index column, because the index column determines the total allocated memory.

Note: Checks on the data range are not implemented!

Note: Due to confusion with the entry point to connecting a fixed size array the use of this function is DEPRECATED *** please use addIndexedItem(...) instead.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | index | Reference to the scalar index column used to determine the size of the array.
  | array | Reference to the Array<TYPE> datatype, which should be connected to the N-tuple.
  | low | Lower edge of client data values allowed to fill into the N-tuple array.
  | high | Upper edge of client data values allowed to fill into the N-tuple array.

Returns:
  StatusCode indicating success or failure.

Definition at line 698 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, DataObject::name(), and NTuple::_Accessor< TYP >::range().

    00703     {
    00704       return i_addItem( name,
    00705                         index->range().distance(),
    00706                         index->name(),
    00707                         TYPE(low),
    00708                         TYPE(high),
    00709                         array.m_ptr);
    00710     }

template<class TYPE, class INDEX, class RANGE>

StatusCode NTuple::Tuple::addIndexedItem | ( | const std::string & | name,
|  | Item< INDEX > & | index,
|  | Array< TYPE > & | array,
|  | const RANGE | low,
|  | const RANGE | high |
| ) |  |  | `[inline]`

Add an indexed Array of data to a column wise N tuple with a range.

You should use this entry point to add a VARIABLE SIZE ARRAY to a column wise N-tuple. The dimension of the array is unspecified and depends on the data range, which you allowed for the index column.

Hence you have to be careful on the allowed data range of the index column, because the index column determines the total allocated memory.

Note: Checks on the data range are not implemented!

Parameters:

  | name | Name of the column in the column wise N-tuple
  | index | Reference to the scalar index column used to determine the size of the array.
  | array | Reference to the Array<TYPE> datatype, which should be connected to the N-tuple.
  | low | Lower edge of client data values allowed to fill into the N-tuple array.
  | high | Upper edge of client data values allowed to fill into the N-tuple array.

Returns:
  StatusCode indicating success or failure.

Definition at line 738 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, DataObject::name(), and NTuple::_Accessor< TYP >::range().

    00743     {
    00744       return i_addItem( name,
    00745                         index->range().distance(),
    00746                         index->name(),
    00747                         TYPE(low),
    00748                         TYPE(high),
    00749                         array.m_ptr);
    00750     }

template<class TYPE, class INDEX>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | Item< INDEX > & | index,
|  | Array< TYPE > & | array |
| ) |  |  | `[inline]`

Add an indexed Array of data to a column wise N tuple.

You should use this entry point to add a VARIABLE SIZE ARRAY to a column wise N-tuple. The dimension of the array is unspecified and depends on the data range, which you allowed for the index column.

Hence, you have to be careful on the allowed data range of the index column, because the index column determines the total allocated memory.

Note: Due to confusion with the entry point to connecting a fixed size array the use of this member function is DEPRECATED *** please use addIndexedItem(...) instead.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | index | Reference to the scalar index column used to determine the size of the array.
  | array | Reference to the Array<TYPE> datatype, which should be connected to the N-tuple.

Returns:
  StatusCode indicating success or failure.

Definition at line 777 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, min, DataObject::name(), and NTuple::_Accessor< TYP >::range().

    00780     {
    00781       return i_addItem( name,
    00782                         index->range().distance(),
    00783                         index->name(),
    00784                         Range<TYPE>::min(),
    00785                         Range<TYPE>::max(),
    00786                         array.m_ptr);
    00787     }

template<class TYPE, class INDEX>

StatusCode NTuple::Tuple::addIndexedItem | ( | const std::string & | name,
|  | Item< INDEX > & | index,
|  | Array< TYPE > & | array |
| ) |  |  | `[inline]`

Add an indexed Array of data to a column wise N tuple.

You should use this entry point to add a VARIABLE SIZE ARRAY to a column wise N-tuple. The dimension of the array is unspecified and depends on the data range, which you allowed for the index column.

Hence, you have to be careful on the allowed data range of the index column, because the index column determines the total allocated memory.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | index | Reference to the scalar index column used to determine the size of the array.
  | array | Reference to the Array<TYPE> datatype, which should be connected to the N-tuple.

Returns:
  StatusCode indicating success or failure.

Definition at line 809 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, min, DataObject::name(), and NTuple::_Accessor< TYP >::range().

    00812     {
    00813       return i_addItem( name,
    00814                         index->range().distance(),
    00815                         index->name(),
    00816                         Range<TYPE>::min(),
    00817                         Range<TYPE>::max(),
    00818                         array.m_ptr);
    00819     }

template<class TYPE>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | long | cols,
|  | long | rows,
|  | Matrix< TYPE > & | matrix |
| ) |  |  | `[inline]`

Add an fixed size Matrix of data to a column wise N tuple.

You should use this entry point to add a FIXED SIZE MATRIX to a column wise N-tuple. The dimension of the matrix must be specified.

Attention: Do not confuse with entry point to add a VARIABLE SIZE MATRIX!

Parameters:

  | name | Name of the column in the column wise N-tuple
  | cols | Number of data columns in the Matrix.
  | rows | Number of data rows in the Matrix.
  | matrix | Reference to the Matrix<TYPE> datatype, which should be connected to the N-tuple.

Returns:
  StatusCode indicating success or failure.

Definition at line 839 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00843     {
    00844       return i_addItem(name,
    00845                        cols,
    00846                        rows,
    00847                        "",
    00848                        Range<TYPE>::min(),
    00849                        Range<TYPE>::max(),
    00850                        matrix.m_ptr);
    00851     }

template<class TYPE, class RANGE>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | long | cols,
|  | long | rows,
|  | Matrix< TYPE > & | result,
|  | const RANGE | low,
|  | const RANGE | high |
| ) |  |  | `[inline]`

Add an fixed size Matrix of data to a column wise N tuple.

You should use this entry point to add a FIXED SIZE MATRIX to a column wise N-tuple. The dimension of the matrix must be specified.

Note: Checks on the data range are not implemented! Attention: Do not confuse with entry point to add a VARIABLE SIZE MATRIX!

Parameters:

  | name | Name of the column in the column wise N-tuple
  | cols | Number of data columns in the Matrix.
  | rows | Number of data rows in the Matrix.
  | matrix | Reference to the Matrix<TYPE> datatype, which should be connected to the N-tuple.
  | low | Lower edge of client data values allowed to fill into the N-tuple matrix.
  | high | Upper edge of client data values allowed to fill into the N-tuple matrix.

Returns:
  StatusCode indicating success or failure.

Definition at line 876 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, and DataObject::name().

    00882     {
    00883       return i_addItem(name,
    00884                        cols,
    00885                        rows,
    00886                        "",
    00887                        TYPE(low),
    00888                        TYPE(high),
    00889                        result.m_ptr);
    00890     }

template<class TYPE, class INDEX>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | Item< INDEX > & | index,
|  | Matrix< TYPE > & | matrix,
|  | long | rows |
| ) |  |  | `[inline]`

Add an variable size Matrix of data to a column wise N tuple.

You should use this entry point to add a VARIABLE SIZE MATRIX to a column wise N-tuple. The number of columns of the matrix is given by the allowed data range of the index column. The number of rows however, which are allowed in the matrix must be specified explicitly and cannot be variable.

Attention: Do not confuse with entry point to add a FIXED SIZE MATRIX.

Note: Due to confusion with the entry point to connecting a fixed size matrix the use of this member function is DEPRECATED *** please use addIndexedItem(...) instead.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | index | Reference to the scalar index column used to determine the number of data columns in the matrix
  | matrix | Reference to the Matrix<TYPE> datatype, which should be connected to the N-tuple.
  | rows | Number of data rows in the Matrix.

Returns:
  StatusCode indicating success or failure.

Definition at line 918 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, min, DataObject::name(), and NTuple::_Accessor< TYP >::range().

    00922     {
    00923       return i_addItem( name,
    00924                         index->range().distance(),
    00925                         rows,
    00926                         index->name(),
    00927                         Range<TYPE>::min(),
    00928                         Range<TYPE>::max(),
    00929                         matrix.m_ptr);
    00930     }

template<class TYPE, class INDEX>

StatusCode NTuple::Tuple::addIndexedItem | ( | const std::string & | name,
|  | Item< INDEX > & | col_index,
|  | long | rows,
|  | Matrix< TYPE > & | matrix |
| ) |  |  | `[inline]`

Add an variable size Matrix of data to a column wise N tuple.

You should use this entry point to add a VARIABLE SIZE MATRIX to a column wise N-tuple. The number of columns of the matrix is given by the allowed data range of the index column. The number of rows however, which are allowed in the matrix must be specified explicitly and cannot be variable.

Attention: Do not confuse with entry point to add a FIXED SIZE MATRIX.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | index | Reference to the scalar index column used to determine the number of data columns in the matrix
  | rows | Number of data rows in the Matrix.
  | matrix | Reference to the Matrix<TYPE> datatype, which should be connected to the N-tuple.

Returns:
  StatusCode indicating success or failure.

Definition at line 953 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, min, DataObject::name(), and NTuple::_Accessor< TYP >::range().

    00957     {
    00958       return i_addItem( name,
    00959                         col_index->range().distance(),
    00960                         rows,
    00961                         col_index->name(),
    00962                         Range<TYPE>::min(),
    00963                         Range<TYPE>::max(),
    00964                         matrix.m_ptr);
    00965     }

template<class TYPE, class INDEX, class RANGE>

StatusCode NTuple::Tuple::addItem | ( | const std::string & | name,
|  | Item< INDEX > & | index,
|  | Matrix< TYPE > & | matrix,
|  | long | rows,
|  | const RANGE | low,
|  | const RANGE | high |
| ) |  |  | `[inline]`

Add an variable size Matrix of data to a column wise N tuple.

You should use this entry point to add a VARIABLE SIZE MATRIX to a column wise N-tuple. The number of columns of the matrix is given by the allowed data range of the index column. The number of rows however, which are allowed in the matrix must be specified explicitly and cannot be variable. Also the range of allowed data values to be filled into the data area of the matrix can be specified.

Note: Checks on the data range are not implemented! Attention: Do not confuse with entry point to add a FIXED SIZE MATRIX.

Note: Due to confusion with the entry point to connecting a fixed size matrix the use of this member function is DEPRECATED *** please use addIndexedItem(...) instead.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | index | Reference to the scalar index column used to determine the number of data columns in the matrix
  | matrix | Reference to the Matrix<TYPE> datatype, which should be connected to the N-tuple.
  | rows | Number of data rows in the Matrix.
  | low | Lower edge of client data values allowed to fill into the N-tuple matrix.
  | high | Upper edge of client data values allowed to fill into the N-tuple matrix.

Returns:
  StatusCode indicating success or failure.

Definition at line 1000 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, DataObject::name(), and NTuple::_Accessor< TYP >::range().

    01006     {
    01007       return i_addItem( name,
    01008                         index->range().distance(),
    01009                         rows,
    01010                         index->name(),
    01011                         TYPE(low),
    01012                         TYPE(high),
    01013                         matrix.m_ptr);
    01014     }

template<class TYPE, class INDEX, class RANGE>

StatusCode NTuple::Tuple::addIndexedItem | ( | const std::string & | name,
|  | Item< INDEX > & | index,
|  | long | rows,
|  | Matrix< TYPE > & | matrix,
|  | const RANGE | low,
|  | const RANGE | high |
| ) |  |  | `[inline]`

Add an variable size Matrix of data to a column wise N tuple.

You should use this entry point to add a VARIABLE SIZE MATRIX to a column wise N-tuple. The number of columns of the matrix is given by the allowed data range of the index column. The number of rows however, which are allowed in the matrix must be specified explicitly and cannot be variable. Also the range of allowed data values to be filled into the data area of the matrix can be specified.

Note: Checks on the data range are not implemented! Attention: Do not confuse with entry point to add a FIXED SIZE MATRIX.

Parameters:

  | name | Name of the column in the column wise N-tuple
  | index | Reference to the scalar index column used to determine the number of data columns in the matrix
  | rows | Number of data rows in the Matrix.
  | matrix | Reference to the Matrix<TYPE> datatype, which should be connected to the N-tuple.
  | low | Lower edge of client data values allowed to fill into the N-tuple matrix.
  | high | Upper edge of client data values allowed to fill into the N-tuple matrix.

Returns:
  StatusCode indicating success or failure.

Definition at line 1044 of file NTuple.h.

References i_addItem(), NTuple::_Accessor< TYP >::m_ptr, DataObject::name(), and NTuple::_Accessor< TYP >::range().

    01050     {
    01051       return i_addItem( name,
    01052                         index->range().distance(),
    01053                         rows,
    01054                         index->name(),
    01055                         TYPE(low),
    01056                         TYPE(high),
    01057                         matrix.m_ptr);
    01058     }

The documentation for this class was generated from the following file:

- /afs/cern.ch/sw/Gaudi/releases/GAUDI/GAUDI_v20r2/GaudiKernel/v25r2/GaudiKernel/NTuple.h